## rustc 1.63.0+dfsg1

=== vendor/sysinfo/Makefile ===
#
# Sysinfo
#
# Copyright (c) 2017 Guillaume Gomez
#

#
# Please note that this Makefile only generates the c example.
#

IDIR = ./src
CC = gcc
CFLAGS = -I$(IDIR)

ODIR = examples/
LDIR = ./target/debug/
LDIR-RELEASE = ./target/release/

LIBS = -lsysinfo -lpthread

_DEPS = sysinfo.h
DEPS = $(patsubst %,$(IDIR)/%,$(_DEPS))

_OBJ = simple.o
OBJ = $(patsubst %,$(ODIR)/%,$(_OBJ))


simple: $(OBJ)
	@echo "Compiling in debug mode"
	cargo build --features=c-interface
	gcc -o $@ $^ $(CFLAGS) -L$(LDIR) $(LIBS)

release: $(OBJ)
	@echo "Compiling in release mode"
	cargo build --features=c-interface --release
	gcc -o simple $^ $(CFLAGS) -L$(LDIR-RELEASE) $(LIBS)

$(ODIR)/%.o: %.c $(DEPS)
	$(CC) -c -o $@ $< $(CFLAGS)

.PHONY: simple

clean:
	@echo "Cleaning mess"
	rm -f $(ODIR)/*.o *~ core $(INCDIR)/*~

=== src/test/run-make-fulldeps/alloc-no-oom-handling/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) --edition=2021 --crate-type=rlib ../../../../library/alloc/src/lib.rs --cfg no_global_oom_handling

=== src/test/run-make-fulldeps/core-no-fp-fmt-parse/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) --edition=2021 --crate-type=rlib ../../../../library/core/src/lib.rs --cfg no_fp_fmt_parse

=== src/test/run-make-fulldeps/coverage-llvmir/Makefile ===
# needs-profiler-support

# Rust coverage maps support LLVM Coverage Mapping Format versions 5 and 6,
# corresponding with LLVM versions 12 and 13, respectively.
# When upgrading LLVM versions, consider whether to enforce a minimum LLVM
# version during testing, with an additional directive at the top of this file
# that sets, for example: `min-llvm-version: 12.0`

-include ../coverage/coverage_tools.mk

BASEDIR=../coverage-llvmir

ifeq ($(UNAME),Darwin)
	INSTR_PROF_DATA_SUFFIX=,regular,live_support
	DATA_SECTION_PREFIX=__DATA,
	LLVM_COV_SECTION_PREFIX=__LLVM_COV,
	COMDAT_IF_SUPPORTED=
else
	INSTR_PROF_DATA_SUFFIX=
	DATA_SECTION_PREFIX=
	LLVM_COV_SECTION_PREFIX=
	COMDAT_IF_SUPPORTED=, comdat
endif

DEFINE_INTERNAL=define internal

ifdef IS_WINDOWS
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK,WINDOWS \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='.lprfd$$M' \
		-DINSTR_PROF_NAME='.lprfn$$M' \
		-DINSTR_PROF_CNTS='.lprfc$$M' \
		-DINSTR_PROF_VALS='.lprfv$$M' \
		-DINSTR_PROF_VNODES='.lprfnd$$M' \
		-DINSTR_PROF_COVMAP='.lcovmap$$M' \
		-DINSTR_PROF_COVFUN='.lcovfun$$M' \
		-DINSTR_PROF_ORDERFILE='.lorderfile$$M'
else
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='$(DATA_SECTION_PREFIX)__llvm_prf_data$(INSTR_PROF_DATA_SUFFIX)' \
		-DINSTR_PROF_NAME='$(DATA_SECTION_PREFIX)__llvm_prf_names' \
		-DINSTR_PROF_CNTS='$(DATA_SECTION_PREFIX)__llvm_prf_cnts' \
		-DINSTR_PROF_VALS='$(DATA_SECTION_PREFIX)__llvm_prf_vals' \
		-DINSTR_PROF_VNODES='$(DATA_SECTION_PREFIX)__llvm_prf_vnds' \
		-DINSTR_PROF_COVMAP='$(LLVM_COV_SECTION_PREFIX)__llvm_covmap' \
		-DINSTR_PROF_COVFUN='$(LLVM_COV_SECTION_PREFIX)__llvm_covfun' \
		-DINSTR_PROF_ORDERFILE='$(DATA_SECTION_PREFIX)__llvm_orderfile'
endif

all: test_llvm_ir

test_llvm_ir:
	# Compile the test program with non-experimental coverage instrumentation, and generate LLVM IR
	$(RUSTC) $(BASEDIR)/testprog.rs \
			-Cinstrument-coverage \
			--emit=llvm-ir

	cat "$(TMPDIR)"/testprog.ll | \
			"$(LLVM_FILECHECK)" $(BASEDIR)/filecheck.testprog.txt $(LLVM_FILECHECK_OPTIONS)

=== src/test/run-make-fulldeps/doctests-keep-binaries/Makefile ===
include ../../run-make-fulldeps/tools.mk

# Check that valid binaries are persisted by running them, regardless of whether the --run or --no-run option is used.

all: run no_run

run:
	mkdir -p $(TMPDIR)/doctests
	$(RUSTC) --crate-type rlib t.rs
	$(RUSTDOC) -Zunstable-options --test --persist-doctests $(TMPDIR)/doctests --extern t=$(TMPDIR)/libt.rlib t.rs
	$(TMPDIR)/doctests/t_rs_2_0/rust_out
	$(TMPDIR)/doctests/t_rs_8_0/rust_out
	rm -rf $(TMPDIR)/doctests

no_run:
	mkdir -p $(TMPDIR)/doctests
	$(RUSTC) --crate-type rlib t.rs
	$(RUSTDOC) -Zunstable-options --test --persist-doctests $(TMPDIR)/doctests --extern t=$(TMPDIR)/libt.rlib t.rs --no-run
	$(TMPDIR)/doctests/t_rs_2_0/rust_out
	$(TMPDIR)/doctests/t_rs_8_0/rust_out
	rm -rf $(TMPDIR)/doctests

=== src/test/run-make-fulldeps/extern-flag-pathless/Makefile ===
-include ../tools.mk

# Test mixing pathless --extern with paths.

all:
	$(RUSTC) bar-static.rs --crate-name=bar --crate-type=rlib
	$(RUSTC) bar-dynamic.rs --crate-name=bar --crate-type=dylib -C prefer-dynamic
	# rlib preferred over dylib
	$(RUSTC) foo.rs --extern bar
	$(call RUN,foo) | $(CGREP) 'static'
	$(RUSTC) foo.rs --extern bar=$(TMPDIR)/libbar.rlib --extern bar
	$(call RUN,foo) | $(CGREP) 'static'
	# explicit --extern overrides pathless
	$(RUSTC) foo.rs --extern bar=$(call DYLIB,bar) --extern bar
	$(call RUN,foo) | $(CGREP) 'dynamic'
	# prefer-dynamic does what it says
	$(RUSTC) foo.rs --extern bar -C prefer-dynamic
	$(call RUN,foo) | $(CGREP) 'dynamic'

=== src/test/run-make-fulldeps/extern-fn-reachable/Makefile ===
-include ../tools.mk

# ignore-windows-msvc

NM=nm -D

ifeq ($(UNAME),Darwin)
NM=nm -gU
endif

ifdef IS_WINDOWS
NM=nm -g
endif

# This overrides the LD_LIBRARY_PATH for RUN
TARGET_RPATH_DIR:=$(TARGET_RPATH_DIR):$(TMPDIR)

all:
	$(RUSTC) dylib.rs -o $(TMPDIR)/libdylib.so -C prefer-dynamic

	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun1)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun2)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun3)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun4)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun5)" -eq "1" ]

=== src/test/run-make-fulldeps/incr-add-rust-src-component/Makefile ===
-include ../tools.mk

# rust-lang/rust#70924: Test that if we add rust-src component in between two
# incremental compiles, the compiler does not ICE on the second.

# This test uses `ln -s` rather than copying to save testing time, but its
# usage doesn't work on windows. So ignore windows.

# ignore-windows

SYSROOT:=$(shell $(RUSTC) --print sysroot)
FAKEROOT=$(TMPDIR)/fakeroot
INCR=$(TMPDIR)/incr

# Make a local copy of the sysroot; then remove the rust-src part of it, if
# present, for the *first* build. Then put in a facsimile of the rust-src
# component for the second build, in order to expose the ICE from issue #70924.
#
# Note that it is much easier to just do `cp -a $(SYSROOT)/* $(FAKEROOT)` as a
# first step, but I am concerned that would be too expensive in a unit test
# compared to making symbolic links.
#
# Anyway, the pattern you'll see here is: For every prefix in
# root/lib/rustlib/src, link all of prefix parent content, then remove the
# prefix, then loop on the next prefix. This way, we basically create a copy of
# the context around root/lib/rustlib/src, and can freely add/remove the src
# component itself.
all:
	mkdir $(FAKEROOT)
	ln -s $(SYSROOT)/* $(FAKEROOT)
	rm -f $(FAKEROOT)/lib
	mkdir $(FAKEROOT)/lib
	ln -s $(SYSROOT)/lib/* $(FAKEROOT)/lib
	rm -f $(FAKEROOT)/lib/rustlib
	mkdir $(FAKEROOT)/lib/rustlib
	ln -s $(SYSROOT)/lib/rustlib/* $(FAKEROOT)/lib/rustlib
	rm -f $(FAKEROOT)/lib/rustlib/src
	mkdir $(FAKEROOT)/lib/rustlib/src
	ln -s $(SYSROOT)/lib/rustlib/src/* $(FAKEROOT)/lib/rustlib/src
	rm -f $(FAKEROOT)/lib/rustlib/src/rust
	$(RUSTC) --sysroot $(FAKEROOT) -C incremental=$(INCR) main.rs
	mkdir -p $(FAKEROOT)/lib/rustlib/src/rust/src/libstd
	touch $(FAKEROOT)/lib/rustlib/src/rust/src/libstd/lib.rs
	$(RUSTC) --sysroot $(FAKEROOT) -C incremental=$(INCR) main.rs

=== src/test/run-make-fulldeps/interdependent-c-libraries/Makefile ===
-include ../tools.mk

# The rust crate foo will link to the native library foo, while the rust crate
# bar will link to the native library bar. There is also a dependency between
# the native library bar to the natibe library foo.
#
# This test ensures that the ordering of -lfoo and -lbar on the command line is
# correct to complete the linkage. If passed as "-lfoo -lbar", then the 'foo'
# library will be stripped out, and the linkage will fail.

all: $(call NATIVE_STATICLIB,foo) $(call NATIVE_STATICLIB,bar)
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(RUSTC) main.rs --print link-args

=== src/test/run-make-fulldeps/libs-through-symlinks/Makefile ===
-include ../tools.mk

# ignore-windows

NAME := $(shell $(RUSTC) --print file-names foo.rs)

all:
	mkdir -p $(TMPDIR)/outdir
	$(RUSTC) foo.rs -o $(TMPDIR)/outdir/$(NAME)
	ln -nsf outdir/$(NAME) $(TMPDIR)
	RUSTC_LOG=rustc_metadata::loader $(RUSTC) bar.rs

=== src/test/run-make-fulldeps/link-path-order/Makefile ===
-include ../tools.mk

# Verifies that the -L arguments given to the linker is in the same order
# as the -L arguments on the rustc command line.

CORRECT_DIR=$(TMPDIR)/correct
WRONG_DIR=$(TMPDIR)/wrong

F := $(call NATIVE_STATICLIB_FILE,foo)

all: $(call NATIVE_STATICLIB,correct) $(call NATIVE_STATICLIB,wrong)
	mkdir -p $(CORRECT_DIR) $(WRONG_DIR)
	mv $(call NATIVE_STATICLIB,correct) $(CORRECT_DIR)/$(F)
	mv $(call NATIVE_STATICLIB,wrong) $(WRONG_DIR)/$(F)
	$(RUSTC) main.rs -o $(TMPDIR)/should_succeed -L $(CORRECT_DIR) -L $(WRONG_DIR)
	$(call RUN,should_succeed)
	$(RUSTC) main.rs -o $(TMPDIR)/should_fail -L $(WRONG_DIR) -L $(CORRECT_DIR)
	$(call FAIL,should_fail)

=== src/test/run-make-fulldeps/longjmp-across-rust/Makefile ===
-include ../tools.mk

all: $(call NATIVE_STATICLIB,foo)
	$(RUSTC) main.rs
	$(call RUN,main)

=== debian/changelog ===
rustc (1.63.0+dfsg1-2) unstable; urgency=medium

  [ Fabian Grünbichler ]
  * fix compiler_builtins linkage on arm(el)
  * add compiler_builtins sync fallbacks for arm(el)

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Sat, 14 Jan 2023 09:38:46 +0100

rustc (1.63.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1018859)

  [ Pietro Albini ]
  * clarify the licensing of the mpsc implementation

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 07 Dec 2022 17:29:00 +0100

rustc (1.63.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Tue, 15 Nov 2022 19:47:53 +0100

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.62.0+dfsg) <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.63.0++)    <!pkg.rustc.dlstage0>,
 llvm-14-dev:native,
 llvm-14-tools:native,
 gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
 gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
 libllvm14 (>= 1:14.0.0),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 wasi-libc (>= 0.0~git20220510.9886d3d~~) <!nowasm>,
 wasi-libc (<= 0.0~git20220510.9886d3d++) <!nowasm>,
 clang-14:native,
Build-Conflicts: gdb-minimal <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends:
 cargo (>= 0.64.0~~), cargo (<< 0.65.0~~),
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 llvm-14,
Suggests:
# lld and clang are needed for wasm compilation
 lld-14, clang-14,
Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.63
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.63 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: libstd-rust-dev-windows
Section: libdevel
Architecture: amd64 i386
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 gcc-mingw-w64-x86-64-posix [amd64],
 gcc-mingw-w64-i686-posix [i386],
Build-Profiles: <!nowindows>
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries including development files,
 needed to cross-compile Rust programs to the *-pc-windows-gnu target
 corresponding to the architecture of this package.

Package: libstd-rust-dev-wasm32
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
# Embeds wasi-libc so doesn't need to depend on it
# None of its licenses require source redistrib, so no need for Built-Using
Recommends:
 lld-14, clang-14,
Suggests:
# nodejs contains wasi-node for running the program
 nodejs (>= 12.16),
Build-Profiles: <!nowasm>
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries including development files,
 needed to cross-compile Rust programs to the wasm32-unknown-unknown and
 wasm32-wasi targets.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-14, ${misc:Depends}, python3-lldb-14
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Recommends: cargo-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

Package: rust-clippy
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends},
 libstd-rust-1.63 (= ${binary:Version})
Recommends: cargo
Description: Rust linter
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains 'clippy', a linter to catch common mistakes and improve
 your Rust code as well a collection of over 400 compatible lints.
 .
 Lints are divided into categories, each with a default lint level. You can
 choose how much Clippy is supposed to annoy help you by changing the lint
 level by category.
 .
 Clippy is integrated into the 'cargo' build tool, available via 'cargo clippy'.

Package: rustfmt

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 14
OLD_LLVM_VERSION = 13
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := true
ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
  BUILD_WASM := false
endif

WINDOWS_SUPPORT := amd64 i386
BUILD_WINDOWS := true
ifneq (,$(findstring nowindows,$(DEB_BUILD_PROFILES)))
  BUILD_WINDOWS := false
endif
ifeq (,$(filter $(DEB_HOST_ARCH), $(WINDOWS_SUPPORT)))
  BUILD_WINDOWS := false
else
  ifeq (,$(filter $(DEB_BUILD_ARCH), $(WINDOWS_SUPPORT)))
    ifeq (true,$(BUILD_WINDOWS))
      $(error cannot cross-compile from $(DEB_BUILD_ARCH) to $(DEB_HOST_ARCH), unless "nowindows" is in DEB_BUILD_PROFILES)
    endif
  endif
  ifeq (i386,$(DEB_HOST_ARCH))
    WINDOWS_ARCH := i686
  else
    WINDOWS_ARCH := x86_64
  endif
endif
# for dh_install substitution variable
export WINDOWS_ARCH

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DVERBOSITY="$(VERBOSITY)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi

## rustc 1.64.0+dfsg1~llvm-0ubuntu0.20.04+10.0trisquel1

=== debian/changelog ===
rustc (1.64.0+dfsg1~llvm-0ubuntu0.20.04+10.0trisquel1) nabia-backports; urgency=medium

  * Import as dependency of newer abrowser deb dependencies.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 19 Jan 2023 17:42:51 +0000

rustc (1.64.0+dfsg1~llvm-0ubuntu0.20.04) focal; urgency=medium

  * Backport to focal
  * Comment out vendored source tracking
  * Re-enable embedded LLVM:
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
    - Adjust debian/watch to include +llvm in upstream version.
    - Remove the rust-all dependency on llvm-14 due to vendoring
  * Revert debhelper compat 13 bump back to 12

 -- Simon Chopin <schopin@ubuntu.com>  Thu, 19 Jan 2023 11:37:39 +0100

rustc (1.64.0+dfsg1-1~exp2ubuntu2) lunar; urgency=medium

  * d/p/ubuntu-Revert-Use-constant-eval-to-do-strict-validity-check.patch:
    revert an upstream patch to work around a riscv64 miscompilation

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 18 Jan 2023 17:39:14 +0100

rustc (1.64.0+dfsg1-1~exp2ubuntu1) lunar; urgency=medium

  * Merge from Debian experimental.
    Remaining changes:
    - Downgrade cargo from rustc Recommends to Suggests to make rustc promotable to
      main.
    - d/control: Add fonts-nanum to the rust-doc deps
    - d/control: Add the rust-doc deps as build-deps for the linkchecker tests
    - Reduce parallelism on all arches other than riscv64 to avoid OOMs
      during build.
    - Explicitly disable LTO
    - Add a self-build autopkgtest
    - Ship the Cargo.lock file along with the compiler to identify which crates
      were bundled in.
    - On i386, only build debuginfo for libstd
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Drop llvm-14 to Suggests for rustc to avoid having to promote it to Ubuntu
      main
    - Add XS-Vendored-Sources-Rust field support
      Needed an extra patch due to rustc being a multi-crate source package.
  * d/control: Update the vendored sources field

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 18 Jan 2023 10:38:19 +0100

rustc (1.64.0+dfsg1-1~exp2) experimental; urgency=medium

  [ Fabian Grünbichler ]
  * d/prune-unused-deps: unify cargo update calls
  * fix rustix on arches requiring outline building
  * fix libstd-rust-dev-windows lintian override
  * fix compiler_builtins linkage on arm(el)
  * add compiler_builtins sync fallbacks for arm(el)
  * fix panicking lldb check on armel

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 11 Jan 2023 17:22:16 +0100

rustc (1.64.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release
  * d/rules: auto_clean: preserve .cargo/config.toml
  * d/rules: also clear bootstrap/rust-analyzer Cargo.lock
  * d/rules: extend privacy-breach removal
  * ship rust-analyzer-proc-macro-srv binary

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Thu, 08 Dec 2022 09:17:59 +0100

rustc (1.63.0+dfsg0ubuntu1-0ubuntu2) lunar; urgency=medium

  * d/control: fix wrong dependencies on previous release

 -- Simon Chopin <schopin@ubuntu.com>  Thu, 01 Dec 2022 16:58:41 +0100

rustc (1.63.0+dfsg0ubuntu1-0ubuntu1) lunar; urgency=medium

  * New upstream release (LP: #1995096)
  * d/copyright: updated (cherry-picked from Debian experimental)

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 30 Nov 2022 18:17:29 +0100

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 12),
# dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.63.0+dfsg) <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.64.0++)    <!pkg.rustc.dlstage0>,
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
 fonts-nanum <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust
XS-Vendored-Sources-Rust: addr2line@0.16.0, addr2line@0.17.0, adler@0.2.3, adler@1.0.2, ahash@0.7.6, aho-corasick@0.7.18, always-assert@0.1.2, ammonia@3.2.0, annotate-snippets@0.8.0, annotate-snippets@0.9.1, ansi_term@0.12.1, anyhow@1.0.60, array_tool@1.0.3, arrayvec@0.7.2, askama@0.11.0, askama_derive@0.11.0, askama_escape@0.10.2, askama_shared@0.12.0, atty@0.2.14, autocfg@1.1.0, backtrace@0.3.66, bitflags@1.3.2, block-buffer@0.10.2, block-buffer@0.7.3, block-padding@0.1.5, bstr@0.2.17, byte-tools@0.3.1, bytecount@0.6.2, byteorder@1.4.3, bytes@1.0.1, camino@1.0.9, cargo-platform@0.1.2, cargo_metadata@0.14.0, cargo_metadata@0.15.0, cc@1.0.73, cfg-if@0.1.10, cfg-if@1.0.0, chalk-derive@0.80.0, chalk-engine@0.80.0, chalk-ir@0.80.0, chalk-solve@0.80.0, chrono@0.4.19, clap@3.2.5, clap_complete@3.1.1, clap_derive@3.2.5, clap_lex@0.2.2, cmake@0.1.48, colored@2.0.0, compiler_builtins@0.1.73, compiletest_rs@0.8.0, core-foundation-sys@0.8.3, countme@3.0.1, cov-mark@2.0.0-pre.1, cpufeatures@0.2.2, crc32fast@1.3.2, crossbeam-channel@0.5.5, crossbeam-deque@0.8.1, crossbeam-epoch@0.9.9, crossbeam-queue@0.3.5, crossbeam-utils@0.8.10, crossbeam@0.8.1, crypto-common@0.1.3, cstr@0.2.8, ctor@0.1.22, dashmap@5.3.4, datafrog@2.0.1, derive-new@0.5.8, diff@0.1.13, digest@0.10.3, digest@0.8.1, dirs-next@2.0.0, dirs-sys-next@0.1.2, dirs-sys@0.3.6, dirs@4.0.0, dissimilar@1.0.4, dlmalloc@0.2.3, drop_bomb@0.1.5, either@1.7.0, elasticlunr-rs@3.0.0, ena@0.14.0, env_logger@0.7.1, env_logger@0.9.0, errno-dragonfly@0.1.2, errno@0.2.8, expect-test@1.4.0, fake-simd@0.1.2, fallible-iterator@0.2.0, fd-lock@3.0.6, filetime@0.2.17, fixedbitset@0.2.0, flate2@1.0.24, fluent-bundle@0.15.2, fluent-langneg@0.13.0, fluent-syntax@0.11.0, fnv@1.0.7, form_urlencoded@1.0.1, fortanix-sgx-abi@0.3.3, fs-err@2.5.0, futf@0.1.5, futures-channel@0.3.19, futures-core@0.3.19, futures-executor@0.3.19, futures-io@0.3.19, futures-macro@0.3.19, futures-sink@0.3.19, futures-task@0.3.19, futures-util@0.3.19, futures@0.3.19, generic-array@0.12.4, generic-array@0.14.5, getopts@0.2.21, getrandom@0.1.14, getrandom@0.2.6, gimli@0.25.0, gimli@0.26.1, glob@0.3.0, globset@0.4.9, gsgdt@0.1.2, handlebars@4.1.0, hashbrown@0.12.3, heck@0.4.0, hermit-abi@0.1.19, hermit-abi@0.2.0, hex@0.4.3, home@0.5.3, html5ever@0.26.0, humantime@1.3.0, humantime@2.0.1, idna@0.2.3, if_chain@1.0.0, ignore@0.4.18, indexmap@1.9.1, indoc@1.0.6, instant@0.1.12, intl-memoizer@0.5.1, intl_pluralrules@7.0.1, io-lifetimes@0.7.2, itertools@0.10.3, itoa@1.0.2, jobserver@0.1.24, jsonpath_lib@0.2.6, lazy_static@1.4.0, libc@0.2.126, libloading@0.7.3, libm@0.1.4, linux-raw-sys@0.0.46, lock_api@0.4.7, log@0.4.17, lsp-types@0.93.0, lzma-sys@0.1.17, mac@0.1.1, maplit@1.0.2, markup5ever@0.11.0, matchers@0.1.0, matches@0.1.9, md-5@0.10.0, mdbook@0.4.21, measureme@10.1.0, memchr@2.5.0, memmap2@0.2.1, memmap2@0.5.4, memoffset@0.6.5, minifier@0.2.1, minimal-lexical@0.2.1, miniz_oxide@0.4.0, miniz_oxide@0.5.3, miow@0.3.7, miow@0.4.0, new_debug_unreachable@1.0.4, nom@7.1.0, ntapi@0.3.7, num-integer@0.1.43, num-traits@0.2.12, num_cpus@1.13.1, object@0.26.2, object@0.29.0, odht@0.3.1, once_cell@1.13.0, opaque-debug@0.2.3, opener@0.5.0, os_str_bytes@6.0.0, output_vt100@0.1.3, packed_simd_2@0.3.4, parking_lot@0.11.2, parking_lot@0.12.1, parking_lot_core@0.8.5, parking_lot_core@0.9.3, pathdiff@0.2.1, percent-encoding@2.1.0, perf-event-open-sys@1.0.1, perf-event@0.4.7, pest@2.1.3, pest_derive@2.1.0, pest_generator@2.1.3, pest_meta@2.1.3, petgraph@0.5.1, phf@0.10.1, phf_codegen@0.10.0, phf_generator@0.10.0, phf_shared@0.10.0, pin-project-lite@0.2.9, pin-utils@0.1.0, pkg-config@0.3.25, polonius-engine@0.13.0, ppv-lite86@0.2.8, precomputed-hash@0.1.1, pretty_assertions@0.7.2, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro-hack@0.5.19, proc-macro2@1.0.40, psm@0.1.16, pulldown-cmark@0.9.2, punycode@0.4.1, quick-error@1.2.3, quick-error@2.0.0, quine-mc_cluskey@0.2.4, quote@1.0.20, rand@0.7.3, rand@0.8.5, rand_chacha@0.2.2, rand_chacha@0.3.0, rand_core@0.5.1, rand_core@0.6.2, rand_hc@0.2.0, rand_xorshift@0.2.0, rand_xoshiro@0.6.0, rayon-core@1.9.3, rayon@1.5.3, redox_syscall@0.2.13, redox_users@0.4.0, regex-automata@0.1.10, regex-syntax@0.6.26, regex@1.5.6, remove_dir_all@0.5.3, rls-data@0.19.1, rls-span@0.5.3, rowan@0.15.8, rustc-ap-rustc_lexer@725.0.0, rustc-demangle@0.1.21, rustc-hash@1.1.0, rustc-rayon-core@0.4.1, rustc-rayon@0.4.0, rustc-semver@1.1.0, rustc_tools_util@0.2.0, rustfix@0.6.1, rustix@0.35.6, rustversion@1.0.5, ryu@1.0.10, same-file@1.0.6, scoped-tls@1.0.0, scopeguard@1.1.0, self_cell@0.10.2, semver@1.0.12, serde@1.0.140, serde_derive@1.0.140, serde_json@1.0.82, serde_repr@0.1.8, sha-1@0.10.0, sha-1@0.8.2, sha2@0.10.2, sharded-slab@0.1.4, shell-escape@0.1.5, shlex@1.0.0, siphasher@0.3.3, slab@0.4.2, smallvec@1.9.0, smol_str@0.1.23, snap@1.0.5, stable_deref_trait@1.2.0, stacker@0.1.14, string_cache@0.8.3, string_cache_codegen@0.5.2, strsim@0.10.0, syn@1.0.98, synstructure@0.12.6, sysinfo@0.24.2, tar@0.4.38, tempfile@3.2.0, tendril@0.4.3, term@0.7.0, termcolor@1.1.2, termize@0.1.1, tester@0.9.0, text-size@1.1.0, textwrap@0.15.0, thiserror-impl@1.0.30, thiserror@1.0.30, thorin-dwp@0.3.0, thread_local@1.1.4, time@0.1.43, tinystr@0.3.4, tinyvec@1.6.0, tinyvec_macros@0.1.0, tokio@1.8.4, toml@0.5.9, topological-sort@0.1.0, tracing-attributes@0.1.22, tracing-core@0.1.28, tracing-log@0.1.3, tracing-subscriber@0.3.14, tracing-tree@0.2.1, tracing@0.1.35, type-map@0.4.0, typenum@1.15.0, ucd-parse@0.1.8, ucd-trie@0.1.3, ungrammar@1.16.1, unic-char-property@0.9.0, unic-char-range@0.9.0, unic-common@0.9.0, unic-emoji-char@0.9.0, unic-langid-impl@0.9.0, unic-langid-macros-impl@0.9.0, unic-langid-macros@0.9.0, unic-langid@0.9.0, unic-ucd-version@0.9.0, unicase@2.6.0, unicode-bidi@0.3.8, unicode-ident@1.0.1, unicode-normalization@0.1.21, unicode-script@0.5.3, unicode-security@0.0.5, unicode-segmentation@1.9.0, unicode-width@0.1.9, unicode-xid@0.2.3, unicode_categories@0.1.1, unified-diff@0.2.1, url@2.2.2, utf-8@0.7.5, valuable@0.1.0, version_check@0.9.4, walkdir@2.3.2, wasi@0.10.2+wasi-snapshot-preview1, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.9.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.5, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.28.0, windows-sys@0.36.1, windows_aarch64_msvc@0.28.0, windows_aarch64_msvc@0.36.1, windows_i686_gnu@0.28.0, windows_i686_gnu@0.36.1, windows_i686_msvc@0.28.0, windows_i686_msvc@0.36.1, windows_x86_64_gnu@0.28.0, windows_x86_64_gnu@0.36.1, windows_x86_64_msvc@0.28.0, windows_x86_64_msvc@0.36.1, write-json@0.1.2, xattr@0.2.3, xflags-macros@0.2.4, xflags@0.2.4, xshell-macros@0.2.2, xshell@0.2.2, xz2@0.1.6, yansi-term@0.1.2

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Suggests:
# lld and clang are needed for wasm compilation
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 cargo (>= 0.65.0~~), cargo (<< 0.66.0~~),
 llvm-14, lld-14, clang-14,
Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.64
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.64 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
